import React, { useState, useEffect, } from "react";
import { useForm } from "react-hook-form";
import { getCookie, setCookie } from 'react-use-cookie';
import Box from '@mui/material/Box';
import InputLabel from '@mui/material/InputLabel';
import InputAdornment from '@mui/material/InputAdornment';
import FormControl from '@mui/material/FormControl';
import TextField from '@mui/material/TextField';
import AccountCircle from '@mui/icons-material/AccountCircle';
import PhoneIcon from '@mui/icons-material/Phone'
import EmailIcon from '@mui/icons-material/Email'
import HomeIcon from '@mui/icons-material/Home'
import { Button, Form, FormGroup, Label } from "reactstrap";
import PasswordIcon from '@mui/icons-material/Password'
import Visibility from '@mui/icons-material/Visibility';
import VisibilityOff from '@mui/icons-material/VisibilityOff';
import IconButton from '@mui/material/IconButton';
import OutlinedInput from '@mui/material/OutlinedInput';
import { useHistory } from "react-router-dom";
import TwitterIcon from '@mui/icons-material/Twitter';
import FacebookIcon from '@mui/icons-material/Facebook';
import LinkedInIcon from '@mui/icons-material/LinkedIn';
import axios from "axios";


function UpdateParnterInfo() {
  const history = useHistory();
  const [myApiResponse, setmyApiResponse] = useState("");
  const [result, setResult] = useState("");
  const [testval, settestval] = useState();
  const [fields1desabled, setfields1desabled] = useState(true);
  const [mailfieldsdesabled, setmailfieldsdesabled] = useState(true);
  const [pwdfieldsdesabled, setpwdfieldsdesabled] = useState(true);


  const [values, setValues] = React.useState({
    password: '',
    showPassword: false,
  });

  const [valuesPass1, setValuesPass1] = React.useState({
    password1: '',
    showPassword1: false,
  });

  const [valuesPass2, setValuesPass2] = React.useState({
    password2: '',
    showPassword2: false,
  });

  const [valuesPass3, setValuesPass3] = React.useState({
    password3: '',
    showPassword3: false,
  });



  const [currentpawdvisible, setcurrentpawdvisible] = useState(false);
  const [newpawdvisible, setnewpawdvisible] = useState(false);
  const [confpwdvisible, setconfpwdvisible] = useState(false);
  const [updatemainmail, setupdatemainmail] = useState();
  const [updatepwd, setupdatepwd] = useState();


  // recuperation et gestion  du token utilisateur 
  const stored_user = getCookie('tokenmysypart');
  if (!stored_user || stored_user.length <= 0) {
    history.push("/PartnerLogin");
  }


  const myserver = "127.0.0.1";
  //const myserver = "89.156.84.196";
  const {
    register,
    formState: { errors },
    handleSubmit,
  } = useForm();


  useEffect(() => {
    getCurrentUserData();
    desablesecurtymailfields();
    desablesecurtypwdfields();
    desablesecurtyInsertKeyfields();
  }, [])



  const [insert_key_api, setinsert_key_api] = useState("");
  const [insert_key_api_message, setinsert_key_api_message] = useState("");
  const [insert_key_updated, setinsert_key_updated] = useState();

  function UpdatePartnerInsertKey() {

    setinsert_key_updated();
    const url = process.env.REACT_APP_API_URL + "myclass/api/update_partner_insert_key/";
    const formData = new FormData();
    formData.append('token', stored_user);

    // Si le partenaire n'est pas connecté, il est renvoyé vers la page de connexion
    if (!stored_user || stored_user.length <= 0) {
      history.push("/PartnerLogin");
    }

    var current_key = document.getElementsByName("current_insert_key")[0].value;
    var new_key = document.getElementsByName("new_insert_key")[0].value;
    var conf_new_key = document.getElementsByName("conf_new_insert_key")[0].value;

   

    document.getElementsByName("identique_insert_key")[0].style.backgroundColor = "white";
    if (new_key !== conf_new_key) {
      document.getElementsByName("identique_insert_key")[0].style.backgroundColor = "red";
      return;
    }

    document.getElementsByName("caractere_insert_key")[0].style.backgroundColor = "white";
    if (String(new_key).length < 8) {
      document.getElementsByName("caractere_insert_key")[0].style.backgroundColor = "red";
      return
    }

    var regex = /\d/g;
    document.getElementsByName("nombre_insert_key")[0].style.backgroundColor = "white";
    if (!regex.test(new_key)) {
      document.getElementsByName("nombre_insert_key")[0].style.backgroundColor = "red";
      return
    }

    const specialChars = /[`!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?~]/;
    document.getElementsByName("special_insert_key")[0].style.backgroundColor = "white";
    if (!specialChars.test(new_key)) {
      document.getElementsByName("special_insert_key")[0].style.backgroundColor = "red";
      return
    } 


    formData.append('current_insert_key', current_key);
    formData.append('new_insert_key', new_key);
    formData.append('conf_insert_key', conf_new_key);



    fetch(
      url,
      {
        method: 'POST',
        body: formData,
      }
    )
      .then((response) => response.json())
      .then((result) => {
        console.log('Success:', result['message'], "result['status'] = ", result['status']);
        setinsert_key_api(result['status']);
        setinsert_key_api_message(result['message']);
        if (String(result['status']) === String("true")) {
          desablesecurtyInsertKeyfields();
          document.getElementsByName("current_insert_key")[0].value = new_key;
          setinsert_key_updated(true);
        }

      })
      .catch((error) => {
        console.error('Error:', error);
        setinsert_key_api("false");
        setinsert_key_updated(false);
      });
  }


  function UpdatePartnerPwd() {

    setupdatepwd(false);
    const url = process.env.REACT_APP_API_URL + "myclass/api/update_partner_pwd/";
    const formData = new FormData();
    formData.append('token', stored_user);

    // Si le partenaire n'est pas connecté, il est renvoyé vers la page de connexion
    if (!stored_user || stored_user.length <= 0) {
      history.push("/PartnerLogin");
    }

    var pwd = document.getElementsByName("current_pwd")[0].value;
    var new_pwd = document.getElementsByName("new_pwd")[0].value;
    var conf_new_pwd = document.getElementsByName("new_pwd_conf")[0].value;


    formData.append('pwd', pwd);
    formData.append('new_pwd', new_pwd);
    formData.append('conf_new_pwd', conf_new_pwd);

    document.getElementsByName("identique")[0].style.backgroundColor = "white";
    if (new_pwd !== conf_new_pwd) {
      document.getElementsByName("identique")[0].style.backgroundColor = "red";
      return;
    }

    document.getElementsByName("caractere")[0].style.backgroundColor = "white";
    if (String(new_pwd).length < 8) {
      document.getElementsByName("caractere")[0].style.backgroundColor = "red";
      return
    }

    var regex = /\d/g;
    document.getElementsByName("nombre")[0].style.backgroundColor = "white";
    if (!regex.test(new_pwd)) {
      document.getElementsByName("nombre")[0].style.backgroundColor = "red";
      return
    }

    const specialChars = /[`!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?~]/;
    document.getElementsByName("special")[0].style.backgroundColor = "white";
    if (!specialChars.test(new_pwd)) {
      document.getElementsByName("special")[0].style.backgroundColor = "red";
      return
    } 

    fetch(
      url,
      {
        method: 'POST',
        body: formData,
      }
    )
      .then((response) => response.json())
      .then((result) => {
        console.log('Success:', result['message'], "result['status'] = ", result['status']);
        setmyApiResponse(result['status']);
        setResult(result['message']);
        if (String(result['status']) == String("true")) {
          setupdatepwd(true);
        }

      })
      .catch((error) => {
        console.error('Error:', error);
        setmyApiResponse("false");
        setupdatepwd(false);
      });
  }


  function UpdatePartnerMail() {

    setupdatemainmail(false);
    const url = process.env.REACT_APP_API_URL + "myclass/api/update_partner_main_mail/";
    const formData = new FormData();
    formData.append('token', stored_user);

    // Si le partenaire n'est pas connecté, il est renvoyé vers la page de connexion
    if (!stored_user || stored_user.length <= 0) {
      history.push("/PartnerLogin");
    }

    var mail = document.getElementsByName("current_email")[0].value;
    var new_mail = document.getElementsByName("new_email")[0].value;
    var conf_new_mail = document.getElementsByName("conf_new_email")[0].value;


    formData.append('mail', mail);
    formData.append('new_mail', new_mail);
    formData.append('conf_new_mail', conf_new_mail);


    fetch(
      url,
      {
        method: 'POST',
        body: formData,
      }
    )
      .then((response) => response.json())
      .then((result) => {
        console.log('Success:', result['message'], "result['status'] = ", result['status']);
        setmyApiResponse(result['status']);
        setResult(result['message']);
        if (String(result['status']) == String("true")) {
          setupdatemainmail(true);
        }

      })
      .catch((error) => {
        console.error('Error:', error);
        setmyApiResponse("false");
        setupdatemainmail(false);
      });



  }


  function getCurrentUserData() {

    settestval('d'); // ==> Do not delete
    const formData = new FormData();
    const url = process.env.REACT_APP_API_URL + "myclass/api/get_partner_account/";
    formData.append('token', stored_user);

    axios.post(url, formData).then(res => {
      if (res.data.status != "False") {
        //console.log(" In test  res.data.status = " + res.data.status);
        //console.log(" In test  res.data.message = " + res.data.message);
        setmyApiResponse("True");
        setResult(res.data.message);

        var mylocaltraining = JSON.parse(res.data.message);
        if (mylocaltraining) {

          if (mylocaltraining.adr_city) {
            document.getElementsByName("adr_city")[0].value = mylocaltraining.adr_city;
            document.getElementsByName("adr_city")[0].disabled = true;
            document.getElementsByName("adr_city")[0].style.backgroundColor = "#ECEFF1";
          }


          if (mylocaltraining.adr_city) {
            document.getElementsByName("adr_zip")[0].value = mylocaltraining.adr_zip;
            document.getElementsByName("adr_zip")[0].disabled = true;
            document.getElementsByName("adr_zip")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.email) {
            document.getElementsByName("email")[0].value = mylocaltraining.email;
            document.getElementsByName("email")[0].disabled = true;
            document.getElementsByName("email")[0].style.backgroundColor = "#ECEFF1";
          }



          if (mylocaltraining.adr_country) {
            document.getElementsByName("adr_country")[0].value = mylocaltraining.adr_country;
            document.getElementsByName("adr_country")[0].disabled = true;
            document.getElementsByName("adr_country")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.link_facebook) {
            document.getElementsByName("link_facebook")[0].value = mylocaltraining.link_facebook;
            document.getElementsByName("link_facebook")[0].disabled = true;
            document.getElementsByName("link_facebook")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.telephone) {
            document.getElementsByName("telephone")[0].value = mylocaltraining.telephone;
            document.getElementsByName("telephone")[0].disabled = true;
            document.getElementsByName("telephone")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.link_linkedin) {
            document.getElementsByName("link_linkedin")[0].value = mylocaltraining.link_linkedin;
            document.getElementsByName("link_linkedin")[0].disabled = true;
            document.getElementsByName("link_linkedin")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.link_twitter) {
            document.getElementsByName("link_twitter")[0].value = mylocaltraining.link_twitter;
            document.getElementsByName("link_twitter")[0].disabled = true;
            document.getElementsByName("link_twitter")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.adr_street) {
            document.getElementsByName("adr_street")[0].value = mylocaltraining.adr_street;
            document.getElementsByName("adr_street")[0].disabled = true;
            document.getElementsByName("adr_street")[0].style.backgroundColor = "#ECEFF1";
          }


          if (mylocaltraining.nom) {
            document.getElementsByName("nom")[0].value = mylocaltraining.nom;
            document.getElementsByName("nom")[0].disabled = true;
            document.getElementsByName("nom")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.contact_tel) {
            document.getElementsByName("contact_tel")[0].value = mylocaltraining.contact_tel;
            document.getElementsByName("contact_tel")[0].disabled = true;
            document.getElementsByName("contact_tel")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.contact_nom) {
            document.getElementsByName("contact_nom")[0].value = mylocaltraining.contact_nom;
            document.getElementsByName("contact_nom")[0].disabled = true;
            document.getElementsByName("contact_nom")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.contact_prenom) {
            document.getElementsByName("contact_prenom")[0].value = mylocaltraining.contact_prenom;
            document.getElementsByName("contact_prenom")[0].disabled = true;
            document.getElementsByName("contact_prenom")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.contact_mail) {
            document.getElementsByName("contact_mail")[0].value = mylocaltraining.contact_mail;
            document.getElementsByName("contact_mail")[0].disabled = true;
            document.getElementsByName("contact_mail")[0].style.backgroundColor = "#ECEFF1";
          }

          if (mylocaltraining.insert_key) {
            document.getElementsByName("current_insert_key")[0].value = mylocaltraining.insert_key;
            document.getElementsByName("current_insert_key")[0].disabled = true;
            document.getElementsByName("current_insert_key")[0].style.backgroundColor = "#ECEFF1";
          }


          desablefield1();

        }
      }
      else {
        //console.log(" In test  res.data.status = " + res.data.status);
        //console.log(" In test  res.data.message = " + res.data.message);
        setmyApiResponse("False");
        //setmyApimyApiMessage("")
      }


    }).catch((error) => {
      console.warn('Not good man :( mysearchtext = ');
      setmyApiResponse("False");
      //setmyApimyApiMessage("")
    })



  }

  function desablefield1() {
    document.getElementsByName("adr_city")[0].disabled = true;
    document.getElementsByName("adr_city")[0].style.backgroundColor = "#ECEFF1";


    document.getElementsByName("adr_city")[0].disabled = true;
    document.getElementsByName("adr_city")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("adr_zip")[0].disabled = true;
    document.getElementsByName("adr_zip")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("adr_country")[0].disabled = true;
    document.getElementsByName("adr_country")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("telephone")[0].disabled = true;
    document.getElementsByName("telephone")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("link_facebook")[0].disabled = true;
    document.getElementsByName("link_facebook")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("link_linkedin")[0].disabled = true;
    document.getElementsByName("link_linkedin")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("link_twitter")[0].disabled = true;
    document.getElementsByName("link_twitter")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("adr_street")[0].disabled = true;
    document.getElementsByName("adr_street")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("nom")[0].disabled = true;
    document.getElementsByName("nom")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("contact_tel")[0].disabled = true;
    document.getElementsByName("contact_tel")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("contact_nom")[0].disabled = true;
    document.getElementsByName("contact_nom")[0].style.backgroundColor = "#ECEFF1";


    document.getElementsByName("contact_prenom")[0].disabled = true;
    document.getElementsByName("contact_prenom")[0].style.backgroundColor = "#ECEFF1";

    document.getElementsByName("contact_mail")[0].disabled = true;
    document.getElementsByName("contact_mail")[0].style.backgroundColor = "#ECEFF1";


    setfields1desabled(true);
  }


  function enablefieds1() {
    document.getElementsByName("adr_city")[0].disabled = false;
    document.getElementsByName("adr_city")[0].style.backgroundColor = "";

    document.getElementsByName("adr_city")[0].disabled = false;
    document.getElementsByName("adr_city")[0].style.backgroundColor = "";

    document.getElementsByName("adr_zip")[0].disabled = false;
    document.getElementsByName("adr_zip")[0].style.backgroundColor = "";

    document.getElementsByName("adr_country")[0].disabled = false;
    document.getElementsByName("adr_country")[0].style.backgroundColor = "";

    document.getElementsByName("telephone")[0].disabled = false;
    document.getElementsByName("telephone")[0].style.backgroundColor = "";

    document.getElementsByName("link_facebook")[0].disabled = false;
    document.getElementsByName("link_facebook")[0].style.backgroundColor = "";

    document.getElementsByName("link_linkedin")[0].disabled = false;
    document.getElementsByName("link_linkedin")[0].style.backgroundColor = "";

    document.getElementsByName("link_twitter")[0].disabled = false;
    document.getElementsByName("link_twitter")[0].style.backgroundColor = "";

    document.getElementsByName("adr_street")[0].disabled = false;
    document.getElementsByName("adr_street")[0].style.backgroundColor = "";

    document.getElementsByName("nom")[0].disabled = false;
    document.getElementsByName("nom")[0].style.backgroundColor = "";

    document.getElementsByName("contact_tel")[0].disabled = false;
    document.getElementsByName("contact_tel")[0].style.backgroundColor = "";

    document.getElementsByName("contact_nom")[0].disabled = false;
    document.getElementsByName("contact_nom")[0].style.backgroundColor = "";

    document.getElementsByName("contact_prenom")[0].disabled = false;
    document.getElementsByName("contact_prenom")[0].style.backgroundColor = "";

    document.getElementsByName("contact_mail")[0].disabled = false;
    document.getElementsByName("contact_mail")[0].style.backgroundColor = "";

    setfields1desabled(false);
  }


  function desablesecurtymailfields() {
    document.getElementsByName("current_email")[0].disabled = true;
    document.getElementsByName("current_email")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("current_email")[0].value = "";


    document.getElementsByName("new_email")[0].disabled = true;
    document.getElementsByName("new_email")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("new_email")[0].value = "";


    document.getElementsByName("conf_new_email")[0].disabled = true;
    document.getElementsByName("conf_new_email")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("conf_new_email")[0].value = "";


    setmailfieldsdesabled(true);
  }



  function enablesecurtymailfields() {


    document.getElementsByName("current_email")[0].disabled = false;
    document.getElementsByName("current_email")[0].style.backgroundColor = "";



    document.getElementsByName("new_email")[0].disabled = false;
    document.getElementsByName("new_email")[0].style.backgroundColor = "";

    document.getElementsByName("conf_new_email")[0].disabled = false;
    document.getElementsByName("conf_new_email")[0].style.backgroundColor = "";


    setmailfieldsdesabled(false);
  }



  function desablesecurtypwdfields() {
    document.getElementsByName("current_pwd")[0].disabled = true;
    document.getElementsByName("current_pwd")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("current_pwd")[0].value = "";

    document.getElementsByName("new_pwd")[0].disabled = true;
    document.getElementsByName("new_pwd")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("new_pwd")[0].value = "";

    document.getElementsByName("new_pwd_conf")[0].disabled = true;
    document.getElementsByName("new_pwd_conf")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("new_pwd_conf")[0].value = "";


    setpwdfieldsdesabled(true);
  }



  function enablesecurtypwdfields() {

    document.getElementsByName("current_pwd")[0].disabled = false;
    document.getElementsByName("current_pwd")[0].style.backgroundColor = "";

    document.getElementsByName("new_pwd")[0].disabled = false;
    document.getElementsByName("new_pwd")[0].style.backgroundColor = "";

    document.getElementsByName("new_pwd_conf")[0].disabled = false;
    document.getElementsByName("new_pwd_conf")[0].style.backgroundColor = "";

    setpwdfieldsdesabled(false);
  }


  function RecordData() {
    const formData = new FormData();
    const url = process.env.REACT_APP_API_URL + "myclass/api/update_partner_account/";

    var adr_city = document.getElementsByName("adr_city")[0].value;
    var adr_zip = document.getElementsByName("adr_zip")[0].value;
    var adr_country = document.getElementsByName("adr_country")[0].value;
    var telephone = document.getElementsByName("telephone")[0].value;
    var link_facebook = document.getElementsByName("link_facebook")[0].value;
    var link_linkedin = document.getElementsByName("link_linkedin")[0].value;
    var link_twitter = document.getElementsByName("link_twitter")[0].value;
    var adr_street = document.getElementsByName("adr_street")[0].value;
    var nom = document.getElementsByName("nom")[0].value;
    var contact_nom = document.getElementsByName("contact_nom")[0].value;

    var contact_prenom = document.getElementsByName("contact_prenom")[0].value;
    var contact_tel = document.getElementsByName("contact_tel")[0].value;
    var contact_mail = document.getElementsByName("contact_mail")[0].value;



    formData.append('token', stored_user);
    formData.append('nom', nom);
    formData.append('adr_city', adr_city);
    formData.append('adr_zip', adr_zip);
    formData.append('telephone', telephone);
    formData.append('adr_country', adr_country);
    formData.append('link_facebook', link_facebook);
    formData.append('link_twitter', link_twitter);
    formData.append('adr_street', adr_street);
    formData.append('contact_nom', contact_nom);
    formData.append('contact_prenom', contact_prenom);
    formData.append('link_linkedin', link_linkedin);
    formData.append('contact_tel', contact_tel);
    formData.append('contact_mail', contact_mail);


    fetch(
      url,
      {
        method: 'POST',
        body: formData,
      }
    )
      .then((response) => response.json())
      .then((result) => {
        console.log('Success:', result['message'], "result['status'] = ", result['status']);
        setmyApiResponse(result['status']);
        setResult(result['message']);
        if (String(result['status']) == String("true")) {
          settestval(true);
          desablefield1();
        }

      })
      .catch((error) => {
        console.error('Error:', error);
        setmyApiResponse("false");
      });


  };


  function handleChange(prop) {
    return (event) => {
      setValues({ ...values, [prop]: event.target.value });
    };
  }


  function handleChange1(prop) {
    return (event) => {
      setValuesPass1({ ...valuesPass1, [prop]: event.target.value });
    };
  }

  function handleChange2(prop) {
    return (event) => {
      setValuesPass2({ ...valuesPass2, [prop]: event.target.value });
    };
  }

  function handleChange3(prop) {
    return (event) => {
      setValuesPass3({ ...valuesPass3, [prop]: event.target.value });
    };
  }


  const handleClickShowPassword_current_pwd = () => {
    var filtre2_value = document.getElementsByName("current_pwd")[0].value;

    if (currentpawdvisible == false) {
      document.getElementsByName("current_pwd")[0].type = "text";
      setcurrentpawdvisible(true);
    }
    else if (currentpawdvisible == true) {
      document.getElementsByName("current_pwd")[0].type = "password";
      setcurrentpawdvisible(false);
    }

  };


  const handleClickShowPassword_new_pwd = () => {
    if (newpawdvisible == false) {
      document.getElementsByName("new_pwd")[0].type = "text";
      setnewpawdvisible(true);
    }
    else if (newpawdvisible == true) {
      document.getElementsByName("new_pwd")[0].type = "password";
      setnewpawdvisible(false);
    }
  };


  const handleClickShowPassword_new_pwd_conf = () => {
    if (confpwdvisible == false) {
      document.getElementsByName("new_pwd_conf")[0].type = "text";
      setconfpwdvisible(true);
    }
    else if (confpwdvisible == true) {
      document.getElementsByName("new_pwd_conf")[0].type = "password";
      setconfpwdvisible(false);
    }

  };

  const handleMouseDownPassword = (event) => {
    event.preventDefault();
  };

  const [insert_keyfieldsdesabled, setinsert_keyfieldsdesabled] = useState(true);

  // Gestion champs caché : Current_Insertion_Key
  const [values_current_insert_key, setvalues_current_insert_key] = React.useState({
    current_insert_key: '',
    showCurrent_insert_key: false,
  });


  const [valuescurrent_insert_key, setvaluescurrent_insert_key] = React.useState({
    password_insert_current_key: '',
    showpassword_insert_current_key: false,
  });

  const [current_insert_key_visible, setcurrent_insert_key_visible] = useState(false);

  function handleChange_current_insert_key(prop) {
    return (event) => {
      setvaluescurrent_insert_key({ ...current_insert_key_visible, [prop]: event.target.value });
    };
  }

  const handleClickcurrent_insert_key = () => {
    if (current_insert_key_visible == false) {
      document.getElementsByName("current_insert_key")[0].type = "text";
      setcurrent_insert_key_visible(true);
    }
    else if (current_insert_key_visible == true) {
      document.getElementsByName("current_insert_key")[0].type = "password";
      setcurrent_insert_key_visible(false);
    }
  };
  // FIN Gestion champs caché : Current_Insertion_Key

  // Gestion champs caché : new_Insertion_Key
  const [values_new_insert_key, setvalues_new_insert_key] = React.useState({
    new_insert_key: '',
    shownew_insert_key: false,
  });


  const [valuesnew_insert_key, setvaluesnew_insert_key] = React.useState({
    password_insert_new_key: '',
    showpassword_insert_new_key: false,
  });

  const [new_insert_key_visible, setnew_insert_key_visible] = useState(false);

  function handleChange_new_insert_key(prop) {
    return (event) => {
      setvaluesnew_insert_key({ ...new_insert_key_visible, [prop]: event.target.value });
    };
  }

  const handleClicknew_insert_key = () => {
    if (new_insert_key_visible == false) {
      document.getElementsByName("new_insert_key")[0].type = "text";
      setnew_insert_key_visible(true);
    }
    else if (new_insert_key_visible == true) {
      document.getElementsByName("new_insert_key")[0].type = "password";
      setnew_insert_key_visible(false);
    }
  };
  // FIN Gestion new champs caché : new_insertion_Key

  // Gestion champs caché : conf_new_Insertion_Key
  const [values_conf_new_insert_key, setvalues_conf_new_insert_key] = React.useState({
    conf_new_insert_key: '',
    showconf_new_insert_key: false,
  });


  const [valuesconf_new_insert_key, setvaluesconf_new_insert_key] = React.useState({
    password_insertconf_new_key: '',
    showpassword_insertconf_new_key: false,
  });

  const [conf_new_insert_key_visible, setconf_new_insert_key_visible] = useState(false);

  function handleChangeconf_new_insert_key(prop) {
    return (event) => {
      setvaluesconf_new_insert_key({ ...conf_new_insert_key_visible, [prop]: event.target.value });
    };
  }

  const handleClickconf_new_insert_key = () => {
    if (conf_new_insert_key_visible == false) {
      document.getElementsByName("conf_new_insert_key")[0].type = "text";
      setconf_new_insert_key_visible(true);
    }
    else if (conf_new_insert_key_visible == true) {
      document.getElementsByName("conf_new_insert_key")[0].type = "password";
      setconf_new_insert_key_visible(false);
    }
  };
  // FIN Gestion new champs caché : conf_new_insertion_Key

  function desablesecurtyInsertKeyfields() {

    setinsert_key_updated();
    document.getElementsByName("current_insert_key")[0].disabled = true;
    document.getElementsByName("current_insert_key")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("current_insert_key")[0].value = "";

    document.getElementsByName("new_insert_key")[0].disabled = true;
    document.getElementsByName("new_insert_key")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("new_insert_key")[0].value = "";

    document.getElementsByName("conf_new_insert_key")[0].disabled = true;
    document.getElementsByName("conf_new_insert_key")[0].style.backgroundColor = "#ECEFF1";
    document.getElementsByName("conf_new_insert_key")[0].value = "";


    setinsert_keyfieldsdesabled(true);
  }




  function enablesecurtyInsertKeyfields() {

    setinsert_key_updated();
    document.getElementsByName("current_insert_key")[0].disabled = false;
    document.getElementsByName("current_insert_key")[0].style.backgroundColor = "";


    document.getElementsByName("new_insert_key")[0].disabled = false;
    document.getElementsByName("new_insert_key")[0].style.backgroundColor = "";

    document.getElementsByName("conf_new_insert_key")[0].disabled = false;
    document.getElementsByName("conf_new_insert_key")[0].style.backgroundColor = "";


    setinsert_keyfieldsdesabled(false);
  }

  return (
    <div className='updateparnterinfo'>

      <div className="titre1"> Données personnelles </div>


      {testval == true && <div className="okUpdateData">
        Les données ont été mise à jour.
      </div>
      }

      {testval == false && <div className="koUpdateData">
        Erreur mise à jour.
      </div>
      }


      <Box alignItems="left" sx={{ '& > :not(style)': { m: 1 }, width: '100%', }}>

        <TextField
          required
          label="Raison sociale"
          name="nom"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <AccountCircle />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />


        <TextField
          name="telephone"
          label="Telephone"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <PhoneIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />


        <TextField
          name="email"
          label="Adresse mail"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <EmailIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <br />

        <TextField
          name="link_linkedin"
          label="LinkedIn"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <LinkedInIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />


        <TextField
          name="link_facebook"
          label="Facebook"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <FacebookIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />


        <TextField
          name="link_twitter"
          label="Twitter"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <TwitterIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <br />
        <TextField
          name="adr_street"
          label="Adresse"
          className="texte_area_adress"
          sx={{ m: 1, width: '90%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <HomeIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <br />
        <TextField
          name="adr_zip"
          label="Code Postal"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <HomeIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />

        <TextField
          name="adr_city"
          label="Ville"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <HomeIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <br />
        <TextField
          name="adr_country"
          label="Pays"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <HomeIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />

        <div style={{ "width": "10%" }}> &nbsp;</div>
        <div className="titre1"> Info Contact </div>

        <TextField
          name="contact_nom"
          label="Nom Contact"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <AccountCircle />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />

        <TextField
          name="contact_prenom"
          label="Prénom Contact"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <AccountCircle />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <br />
        <TextField
          name="contact_tel"
          label="Tel Contact"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <PhoneIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <TextField
          name="contact_mail"
          label="Mail Contact"
          className="texte_area"
          sx={{ m: 1, width: '48%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <EmailIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />

        <div className="div_row22">
          {fields1desabled == false && <div className="div_row">
            <div className="div_row_gauche">
              <Button variant="contained" color="success" className="div_row22 btn_enreg " onClick={RecordData}>Enregister</Button>
            </div>
            <div className="div_row_droite">
              <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={desablefield1}>Annuler</Button>
            </div>
          </div>

          }
          {fields1desabled == true &&
            <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={enablefieds1}>Editer</Button>
          }

        </div>
      </Box>

      <div style={{ "width": "10%" }}> &nbsp;</div>

      <div className="div_row_gauche">
        <div className="titre1"> Mot de passe </div>
        {updatepwd == false && <div className="koUpdateData">
          Erreur mise à jour.
        </div>
        }

        {updatepwd == true && <div className="okUpdateData">
          La mise à jour été faite
        </div>
        }
        <Box alignItems="left" sx={{ '& > :not(style)': { m: 1 } }}>

          <FormControl sx={{ m: 1, width: '90%' }} variant="standard" size="small" className="texte_area_passwd">
            <Label>Mot de passe actuel</Label>
            <InputLabel htmlFor="outlined-adornment-password"></InputLabel>
            <OutlinedInput
              id="current_pwd"
              name="current_pwd"
              type={values.showPassword1 ? 'text' : 'password'}
              value={values.password1}
              onChange={handleChange1('password1')}
              endAdornment={
                <InputAdornment position="end">
                  <IconButton
                    aria-label="toggle password visibility"
                    onClick={handleClickShowPassword_current_pwd}
                    edge="end"
                  >
                    {currentpawdvisible ? <Visibility /> : <VisibilityOff />}
                  </IconButton>
                </InputAdornment>
              }

            />
          </FormControl>


          <FormControl sx={{ m: 1, width: '90%' }} variant="standard" size="small" className="texte_area_passwd">
            <Label>Nouveau mot de passe</Label>
            <InputLabel htmlFor="outlined-adornment-password2"></InputLabel>
            <OutlinedInput
              id="new_pwd"
              name="new_pwd"
              type={values.showPassword ? 'text' : 'password'}
              value={values.password2}
              onChange={handleChange2('password2')}
              endAdornment={
                <InputAdornment position="end">
                  <IconButton
                    aria-label="toggle password visibility"
                    onClick={handleClickShowPassword_new_pwd}
                    edge="end"
                  >
                    {newpawdvisible ? <Visibility /> : <VisibilityOff />}
                  </IconButton>
                </InputAdornment>
              }

            />
          </FormControl>

          <FormControl sx={{ m: 1, width: '90%' }} variant="standard" size="small" className="texte_area_passwd">
            <Label>Confirmation du nouveau mot de passe</Label>
            <InputLabel htmlFor="outlined-adornment-password"></InputLabel>
            <OutlinedInput
              id="new_pwd_conf"
              name="new_pwd_conf"
              type={values.showPassword ? 'text' : 'password'}
              value={values.password3}
              onChange={handleChange3('password3')}
              endAdornment={
                <InputAdornment position="end">
                  <IconButton
                    aria-label="toggle password visibility"
                    onClick={handleClickShowPassword_new_pwd_conf}
                    onMouseDown={handleMouseDownPassword}
                    edge="end"
                  >
                    {confpwdvisible ? <Visibility /> : <VisibilityOff />}
                  </IconButton>
                </InputAdornment>
              }

            />
          </FormControl>
          <div className="text_pwd_crit">
            Créez un mot de passe contenant au moins :
            <ul>
              <li name="caractere">
                8 caractères
              </li>
              <li name="nombre">
                1 nombre
              </li>
              <li name="special">
                1 caractère spécial p. ex., $, !, @, %, &
              </li>

              <li name="identique">
                Identiques
              </li>
            </ul>
          </div>

          <div className="div_row22">

            {pwdfieldsdesabled == false && <div className="div_row">
              <div className="div_row_gauche">
                <Button variant="contained" color="success" className="div_row22 btn_enreg " onClick={UpdatePartnerPwd}>Enregister</Button>
              </div>
              <div className="div_row_droite">
                <Button variant="contained" color="success" className="div_row22 btn_modif " onClick={desablesecurtypwdfields}>Annuler</Button>
              </div>
            </div>
            }
            {pwdfieldsdesabled == true &&
              <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={enablesecurtypwdfields}>Editer</Button>
            }
          </div>


        </Box>
      </div>



      <div className="div_row_droite">
        <div className="titre1"> Emails contact </div>
        {updatemainmail === false && <div className="koUpdateData">
          Erreur mise à jour.
        </div>
        }

        {updatemainmail === true && <div className="okUpdateData">
          La mise à jour été faite
        </div>
        }

        <TextField
          name="current_email"
          label="Adresse mail"
          sx={{ m: 1, width: '90%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <EmailIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <br />
        <TextField
          name="new_email"
          label="Nouvelle Adresse mail"
          sx={{ m: 1, width: '90%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <EmailIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <br />
        <TextField
          name="conf_new_email"
          label="Confirmation mail"
          sx={{ m: 1, width: '90%' }}
          InputProps={{
            startAdornment: (
              <InputAdornment position="start">
                <EmailIcon />
              </InputAdornment>
            ),
          }}
          variant="standard"
        />
        <div className="text_pwd_crit">
          &nbsp;
          <ul style={{ "listStyleType": "none" }}>
            <li>
              &nbsp;
            </li>
            <li>
              &nbsp;
            </li>
            <li>
              &nbsp;
            </li>

            <li>
              &nbsp;
            </li>
          </ul>
        </div>
        {mailfieldsdesabled == false && <div className="div_row" >
          <div className="div_row_gauche" >
            <Button variant="contained" color="success" className="div_row22 btn_enreg " style={{ "marginTop": "0px" }} onClick={UpdatePartnerMail}>Enregister</Button>
          </div>
          <div className="div_row_droite">
            <Button variant="contained" color="success" className="div_row22 btn_modif" style={{ "marginTop": "0px" }} onClick={desablesecurtymailfields}>Annuler</Button>
          </div>
        </div>
        }
        {mailfieldsdesabled == true && <div className="div_row22">
          <Button variant="contained" color="success" className="div_row22 btn_modif" style={{ "marginTop": "0px" }} onClick={enablesecurtymailfields}>Editer</Button>
        </div>
        }




      </div>
      <div style={{ "width": "10%" }}> &nbsp;</div>

      <div style={{ "width": "100%", "float": "left", "marginBottom": "2rem" }}>
        <div style={{ "width": "48%", "float": "left" }}>
          <div className="titre1"> Clé de rattachement  </div>
          {insert_key_updated === false && <div className="koUpdateData">
            Erreur mise à jour {setinsert_key_api_message}
          </div>
          }

          {insert_key_updated === true && <div className="okUpdateData">
            La clé a été correctement mise à jour
          </div>
          }


          <Box alignItems="left" sx={{ '& > :not(style)': { m: 1 } }}>

            <FormControl sx={{ m: 1, width: '90%' }} variant="standard" size="small" className="texte_area_passwd">
              <Label>Clé de rattachement actuelle</Label>
              <InputLabel htmlFor="outlined-adornment-password"></InputLabel>
              <OutlinedInput
                id="current_insert_key"
                name="current_insert_key"
                type={values.current_insert_key ? 'text' : 'password'}
                value={values.current_insert_key}
                onChange={handleChange_current_insert_key('current_insert_key')}
                endAdornment={
                  <InputAdornment position="end">
                    <IconButton
                      aria-label="toggle password visibility"
                      onClick={handleClickcurrent_insert_key}
                      edge="end"
                    >
                      {current_insert_key_visible ? <Visibility /> : <VisibilityOff />}
                    </IconButton>
                  </InputAdornment>
                }

              />
            </FormControl>

            <FormControl sx={{ m: 1, width: '90%' }} variant="standard" size="small" className="texte_area_passwd">
              <Label>Nouvelle clé de rattachement</Label>
              <InputLabel htmlFor="outlined-adornment-password"></InputLabel>
              <OutlinedInput
                id="new_insert_key"
                name="new_insert_key"
                type={values.new_insert_key ? 'text' : 'password'}
                value={values.new_insert_key}
                onChange={handleChange_new_insert_key('current_insert_key')}
                endAdornment={
                  <InputAdornment position="end">
                    <IconButton
                      aria-label="toggle password visibility"
                      onClick={handleClicknew_insert_key}
                      edge="end"
                    >
                      {new_insert_key_visible ? <Visibility /> : <VisibilityOff />}
                    </IconButton>
                  </InputAdornment>
                }

              />
            </FormControl>

            <FormControl sx={{ m: 1, width: '90%' }} variant="standard" size="small" className="texte_area_passwd">
              <Label>Confirmation nouvelle clé de rattachement</Label>
              <InputLabel htmlFor="outlined-adornment-password"></InputLabel>
              <OutlinedInput
                id="conf_new_insert_key"
                name="conf_new_insert_key"
                type={values.new_insert_key ? 'text' : 'password'}
                value={values.new_insert_key}
                onChange={handleChangeconf_new_insert_key('conf_current_insert_key')}
                endAdornment={
                  <InputAdornment position="end">
                    <IconButton
                      aria-label="toggle password visibility"
                      onClick={handleClickconf_new_insert_key}
                      edge="end"
                    >
                      {conf_new_insert_key_visible ? <Visibility /> : <VisibilityOff />}
                    </IconButton>
                  </InputAdornment>
                }

              />
            </FormControl>
            <div className="text_pwd_crit">
            Créez un mot de passe contenant au moins :
            <ul>
              <li name="caractere_insert_key">
                8 caractères
              </li>
              <li name="nombre_insert_key">
                1 nombre
              </li>
              <li name="special_insert_key">
                1 caractère spécial p. ex., $, !, @, %, &
              </li>

              <li name="identique_insert_key">
                Identiques
              </li>
            </ul>
          </div>

            <div className="div_row22">

              {insert_keyfieldsdesabled == false && <div className="div_row">
                <div className="div_row_gauche">
                  <Button variant="contained" color="success" className="div_row22 btn_enreg " onClick={UpdatePartnerInsertKey}>Enregister</Button>
                </div>
                <div className="div_row_droite">
                  <Button variant="contained" color="success" className="div_row22 btn_modif " onClick={desablesecurtyInsertKeyfields}>Annuler</Button>
                </div>
              </div>
              }
              {insert_keyfieldsdesabled == true &&
                <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={enablesecurtyInsertKeyfields}>Editer</Button>
              }
            </div>


          </Box>
        </div>
        <div style={{ "width": "48%", "float": "right" }}>
          &nbsp;

        </div>
      </div>

      <div className="div_row22">
        <div className="titre1"> Supppression de compte </div>
        <div style={{ "marginTop": "1rem", "textAlign": "left" }}>
          Pour supprimer votre compte, veuillez vous rapprocher de votre contact commercial ou nous écrire à contact@mysy-training.com.
        </div>
      </div>
    </div>
  );
}
export default UpdateParnterInfo;